--  ======================
--  Description
--  ======================
--
--  Logika monitoruje stan urządzeń podłączonych do ibvunit na podstawie parametru tslc (czas od ostatniej prawidłowej komunikacji z urządzeniem).
--
--  Należy zbudować listę sterowników z wszystkimi zmiennymi z listy.
--
--  ======================
--  Parameters
--  ======================
--
--  SubLogic supports following variables:
--
--  counter.no                              - ilość monitorowanych urządzeń
--
--  counter.err.state                       - stan błędu urządzeń:
--                                            0 - wszystkie odpowiadają, lub czas do wywołania błędu jeszcze nie upłynął;
--                                            1 - urządzenie nie odpowiada
--                                            2 - zdublowana nazwa urządzenia
--
--  counter.err.srt                         - string zawierający nazwy wszystkich sterowników z błędem
--
--  setting.err.time                        - [s] po tym czasie, jeżeli nie zostanie nawiązana prawidłowa komunikacja z urządzeniem tzn:
--                                                wartość counter.tslc < setting.tslc.limit i wartość counter.tslc <> -1
--                                                zostanie zarejestrowany błąd urządzenia
--
--  setting.tslc.timeout                    - [s] wartość limitu tslc. Jeżeli wartość counter.tslc jest większa niż setting.tslc.timeout to
--                                                fakt ten traktowany jest jako błąd komunikacji ze sterownikiem
--
--  counter.tslc                            - lista - [s] tslc sterownika (-1 oznacza, że sterownik nigdy nie odpowiedział)
--
--  counter.err.downcounter                 - lista - [s] licznik powiązany z setting.err.timer. Jeżeli dojdzie do 0 to zostanie wywołany błąd counter.err.state
--
--  counter.err.state                       - lista - czy urządzenie jest w stanie błędu
--
--  setting.id                              - lista - identyfikator sterownika zgodny z ibvunit (np. rs.0.id.1)
--
--  setting.err.enabled                     - lista - czy błąd komunikacji ma być monitorowany
--
--  ======================
--  mandatory variables
--  ======================
--
--  Logic expects following mandatory variables:
--
--  reload.trigger                          - causes reloading lua script
--
--  memcnt                                  - current amount of memory used by lua in bytes
--
--  Logic expects following kv settings:
--
--  LuaScriptPath                           - path to the lua script - must be absolute
--
--  ======================
--  ChangeLog
--  ======================
--
--  2022-08-02 ver 1.0.0
--
--  # First release
--
-- user can use some functions provided by ibmanager.

-- ibmanager provides following functions to use:
--
-- function returns value of required ibmanager variable
-- @param fullName - string - variable name - name of variable of which value must be returned, for example "rs.0.id.255.input.t.0.value"
-- @return         - string or integer - variable value or "nil" if variable not exist or is not readable
--
-- getValue(fullName)


-- function set value of given ibmanager variable
-- @param fullName - string - variable name - name of variable of which value we want to set, for example "rs.0.id.255.input.t.0.value"
-- @param value    - string, int or boolean - value to set
-- @return         - nothing
--
-- setValue(fullName, value)


-- function returns value of required ibmanager variable
-- @param key      - placed in xml logic configuration file:
--                   * as attribute: Name, in Var, RemoteVar and ImportVar elements in the case of stand alone variables
--                   * as concatenation of two attributes: ListName.Postfix in VarListItem, RemoteVarListItem and ImportVarListItem elements
--                     in the case of variables that are placed in lists
-- @return         - string or integer - variable value or "nil" if variable not exist or is not readable
--
-- getLogicValue(key)


-- function set value of given ibmanager variable
-- @param key      - placed in xml logic configuration file:
--                   * as attribute: Name, in Var, RemoteVar and ImportVar elements in the case of stand alone variables
--                   * as concatenation of two attributes: ListName.Postfix in VarListItem, RemoteVarListItem and ImportVarListItem elements
--                     in the case of variables that are placed in lists
-- @param value    - string, int or boolean - value to set
-- @return         - nothing
--
-- setLogicValue(key, value)

-- function returns two sections of kvsettings from xml configuration file
-- returned value is two element table, each of these elements is table too.
-- indices of returned table are strings and equal "instance" and "global"
-- values of returned tables are tables and contain KVsettings for applicable section.
-- nested tables have form key = value, where key is index in nested table and value is value.
-- example: {"instance" = {"ikey1" = "ivalue1", "ikey2" = "gvalue2"}, "global" = {"gkey1" = "gvalue1", "gkey2" = "gvalue2", "gkey3" = "gvalue3"}}
-- @return          - two dimensional array - kvsettings for global and instance sections
-- getKvSettings()


-- function schedules alert to send.
-- rules are defined in separated alert configuration files and are described in ibmanager instruction manual
-- @param id - alert identifier - must be defined in current logic configuration file in section: <Alert Id="any_identifier" ...
-- scheduleAlert(id)

-- function cancels alert sending, if was previously scheduled. if not then only wakes up alerts handling thread, so if there is no need to call this function, then do not call it.
-- rules are defined in separated alert configuration files and are described in ibmanager instruction manual
-- @param id - alert identifier - must be defined in current logic configuration file in section: <Alert Id="any_identifier" ...
-- cancelAlert(name)

-- function returns table, containing Variables that belongs to required list.
-- @param listName - Name attribute of VarList, RemoteVarList or ImportVarList elemetnst in configurationfile
-- @return array of key-value pairs. Key - variable postfix, Value - Variable value
-- getVarList(listName)

-- function returns monotonic system clock value, that elapsed since specific epoch
-- returned time is expressed in milliseconds.
-- getClock()

-- function logs message to file, if defined in configuration file log level is less than passed to this function
-- @param logLevel - one of:
--        LogLevel.TraceLo
--        LogLevel.Trace
--        LogLevel.TraceHi
--        LogLevel.DebugLo
--        LogLevel.Debug
--        LogLevel.DebugHi
--        LogLevel.Info
--        LogLevel.Notice
--        LogLevel.Warning
--        LogLevel.Error
--        LogLevel.Critical
-- @param logMessage - string to log
-- log(logLevel, logMessage)


-- ibmanager provides following global variables:

-- logic type, (in this case it will always be "Lua") - the same as in logic configuration file in section: <Logic Type="Lua" ...
-- LOGIC_TYPE

-- logic version, the same as in logic configuration file in section: <Logic ... Version="x.y.z" ...
-- LOGIC_VERSION

-- logic sub-type, the same as in logic configuration file in section: <Logic ... SubType="Hysteresis" ...
-- LOGIC_SUBTYPE

-- logic sub-version, the same as in logic configuration file in section: <Logic ... SubVersion="x.y.z" ...
-- LOGIC_SUBVERSION

-- logic instance name - the same as in logic configuration file, in section: <Instance Name="0">
-- LOGIC_INSTANCE_NAME

-- add script directory to package path
package.path = package.path .. ";./logic/scripts/utils/?.lua";

-- use script - without .lua extension - delta class
require("DownCounter");

SUPPORTED_SUBLOGIC_TYPE = "DeviceMonitor";
SUPPORTED_SUBLOGIC_VERSION = "1.0.0";
g_versionChecked = false;

g_devieceCount = 0;
g_checkList = 0;

g_tableDevicesPostfix = {};

g_settingId = {};
g_settingErrEnabled = {};
g_counterTslc = {};
g_counterErrDowncounter = {};
g_counterErrState = {};
g_counterErrDowncounterEnt = {};

-- zwraca 1 jeżeli listy są OK
function checkLists()
  local fail = false

  if (g_devieceCount == 0) then
    log(LogLevel.Error, "VarList setting.id not initialized in instance section of configuration.")
    fail = true
  else
    for i = 0, g_devieceCount - 1, 1 do
      -- Check for fail

      for j = i + 1, g_devieceCount - 1, 1 do
        if g_settingId[g_tableDevicesPostfix[i]] == g_settingId[g_tableDevicesPostfix[j]] then
          log(LogLevel.Error,
            "In initialization section element found duplicated values for list element setting.id: " ..
            g_settingId[g_tableDevicesPostfix[i]] .. ".")
          fail = true
        end
      end


      if g_settingErrEnabled[g_tableDevicesPostfix[i]] then
      else
        log(LogLevel.Error,
          "VarList element setting.err.enabled." ..
          g_tableDevicesPostfix[i] .. " not initialized in instance section of configuration.")
        fail = true
      end

      if g_counterTslc[g_tableDevicesPostfix[i]] then
      else
        log(LogLevel.Error,
          "VarList element counter.tslc." ..
          g_tableDevicesPostfix[i] .. " not initialized in instance section of configuration.")
        fail = true
      end

      if g_counterErrDowncounter[g_tableDevicesPostfix[i]] then
      else
        log(LogLevel.Error,
          "VarList element counter.err.downcounter." ..
          g_tableDevicesPostfix[i] .. " not initialized in instance section of configuration.")
        fail = true
      end

      if g_counterErrState[g_tableDevicesPostfix[i]] then
      else
        log(LogLevel.Error,
          "VarList element counter.err.state." ..
          g_tableDevicesPostfix[i] .. " not initialized in instance section of configuration.")
        fail = true
      end
    end
  end

  if fail then
    return 0
  else
    return 1
  end
end

function readAll(file)
  local f = assert(io.open(file, "rb"))
  local content = f:read("*all")
  f:close()
  return content
end

-- entry point to the logic
function onLogicCall(firstCall)
  if not g_versionChecked then
    -- checking sublogic type and sublogic version
    if LOGIC_SUBTYPE ~= SUPPORTED_SUBLOGIC_TYPE then
      error("Wrong logic sub-type. expected " .. SUPPORTED_SUBLOGIC_TYPE .. " but used " .. LOGIC_SUBTYPE);
    end
    local versionWithoutBuild = string.match(LOGIC_SUBVERSION, "[0-9]+%.[0-9]+%.[0-9]+");
    if versionWithoutBuild ~= SUPPORTED_SUBLOGIC_VERSION then
      error("Wrong logic sub-version. expected " .. SUPPORTED_SUBLOGIC_VERSION .. " but used " .. LOGIC_SUBVERSION);
    end
    g_versionChecked = true;
  end

  local settingErrTime        = getLogicValue("setting.err.time");
  local settingTslcTimeout    = getLogicValue("setting.tslc.timeout");

  local settingId             = getVarList("setting.id");
  local settingErrEnabled     = getVarList("setting.err.enabled");
  local counterTslc           = getVarList("counter.tslc");
  local counterErrDowncounter = getVarList("counter.err.downcounter");
  local counterErrState       = getVarList("counter.err.state");

  local i                     = 0;
  g_devieceCount              = 0;

  -- tablica wartości ID urządzeń
  if settingId ~= nil then
    for postfix, value in pairs(settingId) do
      g_settingId['' .. postfix] = value;

      g_tableDevicesPostfix[g_devieceCount] = postfix
      g_devieceCount = g_devieceCount + 1;
    end
  end

  -- tablica
  if settingErrEnabled ~= nil then
    for postfix, value in pairs(settingErrEnabled) do
      g_settingErrEnabled['' .. postfix] = value;
    end
  end

  -- tablica
  if counterTslc ~= nil then
    for postfix, value in pairs(counterTslc) do
      g_counterTslc['' .. postfix] = value;
    end
  end

  -- tablica
  if counterErrDowncounter ~= nil then
    for postfix, value in pairs(counterErrDowncounter) do
      g_counterErrDowncounter['' .. postfix] = value;
    end
  end

  -- tablica
  if counterErrState ~= nil then
    for postfix, value in pairs(counterErrState) do
      g_counterErrState['' .. postfix] = value;
    end
  end

  if (firstCall) then
    g_checkList = checkLists()
  end

  if g_checkList == 1 then
    local tmp_id;
    local tmp_tlc;
    local counterErrCommState = 0;
    local counterErrCommStr = "";

    for i = 0, g_devieceCount - 1, 1 do
      tmp_id = g_settingId[g_tableDevicesPostfix[i]];
      tmp_tlc = getValue("ibvunit." .. tmp_id .. ".tslc");

      if g_counterErrDowncounterEnt[g_tableDevicesPostfix[i]] == nil or firstCall then
        g_counterErrDowncounterEnt[g_tableDevicesPostfix[i]] = DownCounter.create();
      else
        g_counterErrDowncounterEnt[g_tableDevicesPostfix[i]]:updateParams(settingErrTime * 1000);
      end

      if ((tmp_tlc == -1) or (tmp_tlc > settingTslcTimeout)) and (settingErrEnabled[g_tableDevicesPostfix[i]] == 1) then
        counterErrDowncounter[g_tableDevicesPostfix[i]] = g_counterErrDowncounterEnt[g_tableDevicesPostfix[i]]:timeTo0() /
            1000;
        counterErrDowncounter[g_tableDevicesPostfix[i]] = (counterErrDowncounter[g_tableDevicesPostfix[i]] < 0) and 0 or
            counterErrDowncounter[g_tableDevicesPostfix[i]];

        if g_counterErrDowncounterEnt[g_tableDevicesPostfix[i]]:elapsed() then
          counterErrState[g_tableDevicesPostfix[i]] = 1;
          counterErrCommState = 1;
          counterErrCommStr = counterErrCommStr .. tmp_id .. "; ";
        else
          counterErrState[g_tableDevicesPostfix[i]] = 0;
        end
      else
        g_counterErrDowncounterEnt[g_tableDevicesPostfix[i]]:reset();
        counterErrState[g_tableDevicesPostfix[i]] = 0;
      end

      setLogicValue("counter.tslc." .. g_tableDevicesPostfix[i], tmp_tlc);
      setLogicValue("counter.err.downcounter." .. g_tableDevicesPostfix[i],
        counterErrDowncounter[g_tableDevicesPostfix[i]]);
      setLogicValue("counter.err.state." .. g_tableDevicesPostfix[i], counterErrState[g_tableDevicesPostfix[i]]);

      --print('=================');
      --print('i: ' .. i);
      --print('g_tableDevicesPostfix[i]: ' .. g_tableDevicesPostfix[i]);
      --print('ID: ' .. tmp_id);
      --print('tslc: ' .. tmp_tlc);
      --print('enabled: ' .. settingErrEnabled[g_tableDevicesPostfix[i]]);
    end

    setLogicValue("counter.no", g_devieceCount);
    setLogicValue("counter.err.comm.state", counterErrCommState);
    setLogicValue("counter.err.comm.str", counterErrCommStr);
  else
    setLogicValue("counter.no", 0);
  end
end
